ManifestTask (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs, class: ManifestTask

# Class ManifestTask

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.ManifestTask

All Implemented Interfaces:
  `Cloneable`

public class ManifestTask extends Task
Creates a manifest file for inclusion in a JAR, Ant task wrapper around `Manifest`. This task can be used to write a Manifest file, optionally replacing or updating an existing file.

Since:
  Ant 1.5

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `ManifestTask.Mode`
  Helper class for Manifest's mode attribute.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `VALID_ATTRIBUTE_CHARS`
  Specifies the valid characters which can be used in attribute names.

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ManifestTask()`
  Default constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addConfiguredAttribute(Manifest.Attribute attribute)`
  Add an attribute to the manifest - it is added to the main section.
  `void`
  `addConfiguredSection(Manifest.Section section)`
  Add a section to the manifest
  `void`
  `execute()`
  Create or update the Manifest when used as a task.
  `void`
  `setEncoding(String encoding)`
  The encoding to use for reading in an existing manifest file
  `void`
  `setFile(File f)`
  The name of the manifest file to create/update.
  `void`
  `setFlattenAttributes(boolean b)`
  Whether to flatten multi-valued attributes (i.e.
  `void`
  `setMergeClassPathAttributes(boolean b)`
  Whether to merge Class-Path attributes.
  `void`
  `setMode(ManifestTask.Mode m)`
  Update policy: either "update" or "replace"; default is "replace".

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### VALID_ATTRIBUTE_CHARS

    public static final String VALID_ATTRIBUTE_CHARS
    Specifies the valid characters which can be used in attribute names. "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_"
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ManifestTask

    public ManifestTask()
    Default constructor

- ## Method Details

  - ### addConfiguredSection

    public void addConfiguredSection(Manifest.Section section) throws ManifestException
    Add a section to the manifest
    Parameters:
      `section` - the manifest section to be added
    Throws:
      `ManifestException` - if the section is not valid.

  - ### addConfiguredAttribute

    public void addConfiguredAttribute(Manifest.Attribute attribute) throws ManifestException
    Add an attribute to the manifest - it is added to the main section.
    Parameters:
      `attribute` - the attribute to be added.
    Throws:
      `ManifestException` - if the attribute is not valid.

  - ### setFile

    public void setFile(File f)
    The name of the manifest file to create/update. Required if used as a task.
    Parameters:
      `f` - the Manifest file to be written

  - ### setEncoding

    public void setEncoding(String encoding)
    The encoding to use for reading in an existing manifest file
    Parameters:
      `encoding` - the manifest file encoding.

  - ### setMode

    public void setMode(ManifestTask.Mode m)
    Update policy: either "update" or "replace"; default is "replace".
    Parameters:
      `m` - the mode value - update or replace.

  - ### setMergeClassPathAttributes

    public void setMergeClassPathAttributes(boolean b)
    Whether to merge Class-Path attributes.
    Parameters:
      `b` - boolean
    Since:
      Ant 1.8.0

  - ### setFlattenAttributes

    public void setFlattenAttributes(boolean b)
    Whether to flatten multi-valued attributes (i.e. Class-Path) into a single one.
    Parameters:
      `b` - boolean
    Since:
      Ant 1.8.0

  - ### execute

    public void execute() throws BuildException
    Create or update the Manifest when used as a task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - if the manifest cannot be written.